<?php
//var_dump();
ini_set('date.timezone','Asia/Shanghai');
error_reporting(E_ALL);

require_once "../lib/WxPay.Api.php";
require_once '../lib/WxPay.Notify.php';
require_once 'log.php';

//初始化日志
$logHandler= new CLogFileHandler("../logs/".date('Y-m-d').'.log');
$log = Log::Init($logHandler, 15);

class PayNotifyCallBack extends WxPayNotify
{
	//查询订单
	public function Queryorder($transaction_id)
	{
		$input = new WxPayOrderQuery();
		$input->SetTransaction_id($transaction_id);
		$result = WxPayApi::orderQuery($input);
		Log::DEBUG("query:" . json_encode($result));

		if(array_key_exists("return_code", $result)
			&& array_key_exists("result_code", $result)
			&& $result["return_code"] == "SUCCESS"
			&& $result["result_code"] == "SUCCESS")
		{
			//update
			
			$app_id = $result['appid'];
			$attach = $result['attach'];
			$attach_array = explode("_", $attach);
			$reg_id = $attach_array[0];
			$group_id = $attach_array[1]; 
			$openid = $result['openid'];
			$out_trade_no = $result['out_trade_no'];
			$log_str = "appid:$app_id//attach:$attach// group id = $group_id //open id : $openid";

			//check had update
			include '../../../core/app_top.php';

			$db = new db();

			$sql_check = "select id from race_reg_pay where state  = 2 and reg_id = $reg_id";
			$result_check = $db->get_One($sql_check);

			if(!$result_check)
			{
				$sql = "update race_reg_pay set state = 2,openid='$openid',out_trade_no = '$out_trade_no' where reg_id = $reg_id";
				$sql2 = "update race_reg set state = 3 where id = $reg_id";
				$db->query($sql);
				$db->query($sql2);

				//send sms
				$sql = "select * from race_reg where id = $reg_id";
				$result = $db->get_data($sql);

				$mobi = $result[0]['tel'];

				sendSms($mobi,"您已经成功付款，恭喜您成功报名我们的活动");
			}
			
			$log_str = $log_str . "sql check:$sql_check // sql : $sql // sql2 : $sql2";
			//log out start
			$myfile = fopen("log.txt", "w") or die("Unable to open file!");
			fwrite($myfile, $log_str);
			fclose($myfile);
			//log out end

			return true;
		}
		return false;
	}

	//重写回调处理函数
	public function NotifyProcess($data, &$msg)
	{
		Log::DEBUG("call back:" . json_encode($data));
		$notfiyOutput = array();
		
		if(!array_key_exists("transaction_id", $data)){
			$msg = "输入参数不正确";
			return false;
		}
		//查询订单，判断订单真实性
		if(!$this->Queryorder($data["transaction_id"])){
			$msg = "订单查询失败";
			return false;
		}
		return true;
	}
}

Log::DEBUG("begin notify");
$notify = new PayNotifyCallBack();
$notify->Handle(false);
?>